package javax.swing.text;

import java.awt.Component;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import javax.swing.JComponent;

class DefaultEditorKit$PageDownAction extends TextAction {
   private boolean select;

   DefaultEditorKit$PageDownAction(String var1, boolean var2) {
      super(var1);
      this.select = var2;
   }

   public void actionPerformed(ActionEvent var1) {
      JTextComponent var2 = ((TextAction)this).getTextComponent(var1);
      if (var2 != null) {
         Rectangle var5 = new Rectangle();
         ((JComponent)var2).computeVisibleRect(var5);
         int var3 = var5.y;
         var5.y += var5.height;
         if (var5.y + var5.height > ((JComponent)var2).getHeight()) {
            var5.y = ((JComponent)var2).getHeight() - var5.height;
         }

         var3 = var5.y - var3;
         ((JComponent)var2).scrollRectToVisible(var5);
         int var4 = var2.getCaretPosition();

         try {
            if (var4 != -1) {
               Rectangle var6 = var2.modelToView(var4);
               var6.y += var3;
               var4 = var2.viewToModel(new Point(var6.x, var6.y));
               Document var7 = var2.getDocument();
               if (var4 != 0 && var4 > var7.getLength() - 1) {
                  var4 = var7.getLength() - 1;
               }

               if (var4 < 0) {
                  var4 = 0;
               }

               if (this.select) {
                  var2.moveCaretPosition(var4);
               } else {
                  var2.setCaretPosition(var4);
               }
            }
         } catch (BadLocationException var8) {
            ((Component)var2).getToolkit().beep();
         }
      }

   }
}
