package javax.swing.text;

public class DefaultStyledDocument$ElementSpec {
   public static final short StartTagType = 1;
   public static final short EndTagType = 2;
   public static final short ContentType = 3;
   public static final short JoinPreviousDirection = 4;
   public static final short JoinNextDirection = 5;
   public static final short OriginateDirection = 6;
   public static final short JoinFractureDirection = 7;
   private AttributeSet attr;
   private int len;
   private short type;
   private short direction;
   private int offs;
   private char[] data;

   public DefaultStyledDocument$ElementSpec(AttributeSet var1, short var2) {
      this(var1, var2, (char[])null, 0, 0);
   }

   public DefaultStyledDocument$ElementSpec(AttributeSet var1, short var2, int var3) {
      this(var1, var2, (char[])null, 0, var3);
   }

   public DefaultStyledDocument$ElementSpec(AttributeSet var1, short var2, char[] var3, int var4, int var5) {
      this.attr = var1;
      this.type = var2;
      this.data = var3;
      this.offs = var4;
      this.len = var5;
      this.direction = 6;
   }

   public char[] getArray() {
      return this.data;
   }

   public AttributeSet getAttributes() {
      return this.attr;
   }

   public short getDirection() {
      return this.direction;
   }

   public int getLength() {
      return this.len;
   }

   public int getOffset() {
      return this.offs;
   }

   public short getType() {
      return this.type;
   }

   public void setDirection(short var1) {
      this.direction = var1;
   }

   public void setType(short var1) {
      this.type = var1;
   }

   public String toString() {
      String var1 = "??";
      String var2 = "??";
      switch (this.type) {
         case 1:
            var1 = "StartTag";
            break;
         case 2:
            var1 = "EndTag";
            break;
         case 3:
            var1 = "Content";
      }

      switch (this.direction) {
         case 4:
            var2 = "JoinPrevious";
            break;
         case 5:
            var2 = "JoinNext";
            break;
         case 6:
            var2 = "Originate";
            break;
         case 7:
            var2 = "Fracture";
      }

      return var1 + ":" + var2 + ":" + this.getLength();
   }
}
