package javax.swing.text;

import java.awt.Color;
import java.awt.Component;
import javax.swing.Icon;

public class StyleConstants {
   public static final String ComponentElementName = "component";
   public static final String IconElementName = "icon";
   public static final Object NameAttribute = new StyleConstants("name");
   public static final Object ResolveAttribute = new StyleConstants("resolver");
   public static final Object ModelAttribute = new StyleConstants("model");
   public static final Object BidiLevel;
   public static final Object FontFamily;
   public static final Object FontSize;
   public static final Object Bold;
   public static final Object Italic;
   public static final Object Underline;
   public static final Object StrikeThrough;
   public static final Object Superscript;
   public static final Object Subscript;
   public static final Object Foreground;
   public static final Object Background;
   public static final Object ComponentAttribute;
   public static final Object IconAttribute;
   public static final Object ComposedTextAttribute;
   public static final Object FirstLineIndent;
   public static final Object LeftIndent;
   public static final Object RightIndent;
   public static final Object LineSpacing;
   public static final Object SpaceAbove;
   public static final Object SpaceBelow;
   public static final Object Alignment;
   public static final Object TabSet;
   public static final Object Orientation;
   public static final int ALIGN_LEFT = 0;
   public static final int ALIGN_CENTER = 1;
   public static final int ALIGN_RIGHT = 2;
   public static final int ALIGN_JUSTIFIED = 3;
   private static Object[] keys;
   private String representation;

   static {
      BidiLevel = javax.swing.text.StyleConstants.CharacterConstants.BidiLevel;
      FontFamily = javax.swing.text.StyleConstants.CharacterConstants.Family;
      FontSize = javax.swing.text.StyleConstants.CharacterConstants.Size;
      Bold = javax.swing.text.StyleConstants.CharacterConstants.Bold;
      Italic = javax.swing.text.StyleConstants.CharacterConstants.Italic;
      Underline = javax.swing.text.StyleConstants.CharacterConstants.Underline;
      StrikeThrough = javax.swing.text.StyleConstants.CharacterConstants.StrikeThrough;
      Superscript = javax.swing.text.StyleConstants.CharacterConstants.Superscript;
      Subscript = javax.swing.text.StyleConstants.CharacterConstants.Subscript;
      Foreground = javax.swing.text.StyleConstants.CharacterConstants.Foreground;
      Background = javax.swing.text.StyleConstants.CharacterConstants.Background;
      ComponentAttribute = javax.swing.text.StyleConstants.CharacterConstants.ComponentAttribute;
      IconAttribute = javax.swing.text.StyleConstants.CharacterConstants.IconAttribute;
      ComposedTextAttribute = new StyleConstants("composed text");
      FirstLineIndent = javax.swing.text.StyleConstants.ParagraphConstants.FirstLineIndent;
      LeftIndent = javax.swing.text.StyleConstants.ParagraphConstants.LeftIndent;
      RightIndent = javax.swing.text.StyleConstants.ParagraphConstants.RightIndent;
      LineSpacing = javax.swing.text.StyleConstants.ParagraphConstants.LineSpacing;
      SpaceAbove = javax.swing.text.StyleConstants.ParagraphConstants.SpaceAbove;
      SpaceBelow = javax.swing.text.StyleConstants.ParagraphConstants.SpaceBelow;
      Alignment = javax.swing.text.StyleConstants.ParagraphConstants.Alignment;
      TabSet = javax.swing.text.StyleConstants.ParagraphConstants.TabSet;
      Orientation = javax.swing.text.StyleConstants.ParagraphConstants.Orientation;
      keys = new Object[]{NameAttribute, ResolveAttribute, BidiLevel, FontFamily, FontSize, Bold, Italic, Underline, StrikeThrough, Superscript, Subscript, Foreground, Background, ComponentAttribute, IconAttribute, FirstLineIndent, LeftIndent, RightIndent, LineSpacing, SpaceAbove, SpaceBelow, Alignment, TabSet, Orientation};

      try {
         for(int var0 = 0; var0 < keys.length; ++var0) {
            StyleContext.registerStaticAttributeKey(keys[var0]);
         }
      } catch (Throwable var1) {
         var1.printStackTrace();
      }

   }

   StyleConstants(String var1) {
      this.representation = var1;
   }

   public static int getAlignment(AttributeSet var0) {
      Integer var1 = (Integer)var0.getAttribute(Alignment);
      return var1 != null ? var1 : 0;
   }

   public static Color getBackground(AttributeSet var0) {
      Color var1 = (Color)var0.getAttribute(Background);
      if (var1 == null) {
         var1 = Color.black;
      }

      return var1;
   }

   public static int getBidiLevel(AttributeSet var0) {
      Integer var1 = (Integer)var0.getAttribute(BidiLevel);
      return var1 != null ? var1 : 0;
   }

   public static Component getComponent(AttributeSet var0) {
      return (Component)var0.getAttribute(ComponentAttribute);
   }

   public static float getFirstLineIndent(AttributeSet var0) {
      Float var1 = (Float)var0.getAttribute(FirstLineIndent);
      return var1 != null ? var1 : 0.0F;
   }

   public static String getFontFamily(AttributeSet var0) {
      String var1 = (String)var0.getAttribute(FontFamily);
      if (var1 == null) {
         var1 = "Monospaced";
      }

      return var1;
   }

   public static int getFontSize(AttributeSet var0) {
      Integer var1 = (Integer)var0.getAttribute(FontSize);
      return var1 != null ? var1 : 12;
   }

   public static Color getForeground(AttributeSet var0) {
      Color var1 = (Color)var0.getAttribute(Foreground);
      if (var1 == null) {
         var1 = Color.black;
      }

      return var1;
   }

   public static Icon getIcon(AttributeSet var0) {
      return (Icon)var0.getAttribute(IconAttribute);
   }

   public static float getLeftIndent(AttributeSet var0) {
      Float var1 = (Float)var0.getAttribute(LeftIndent);
      return var1 != null ? var1 : 0.0F;
   }

   public static float getLineSpacing(AttributeSet var0) {
      Float var1 = (Float)var0.getAttribute(LineSpacing);
      return var1 != null ? var1 : 0.0F;
   }

   public static float getRightIndent(AttributeSet var0) {
      Float var1 = (Float)var0.getAttribute(RightIndent);
      return var1 != null ? var1 : 0.0F;
   }

   public static float getSpaceAbove(AttributeSet var0) {
      Float var1 = (Float)var0.getAttribute(SpaceAbove);
      return var1 != null ? var1 : 0.0F;
   }

   public static float getSpaceBelow(AttributeSet var0) {
      Float var1 = (Float)var0.getAttribute(SpaceBelow);
      return var1 != null ? var1 : 0.0F;
   }

   public static TabSet getTabSet(AttributeSet var0) {
      TabSet var1 = (TabSet)var0.getAttribute(TabSet);
      return var1;
   }

   public static boolean isBold(AttributeSet var0) {
      Boolean var1 = (Boolean)var0.getAttribute(Bold);
      return var1 != null ? var1 : false;
   }

   public static boolean isItalic(AttributeSet var0) {
      Boolean var1 = (Boolean)var0.getAttribute(Italic);
      return var1 != null ? var1 : false;
   }

   public static boolean isStrikeThrough(AttributeSet var0) {
      Boolean var1 = (Boolean)var0.getAttribute(StrikeThrough);
      return var1 != null ? var1 : false;
   }

   public static boolean isSubscript(AttributeSet var0) {
      Boolean var1 = (Boolean)var0.getAttribute(Subscript);
      return var1 != null ? var1 : false;
   }

   public static boolean isSuperscript(AttributeSet var0) {
      Boolean var1 = (Boolean)var0.getAttribute(Superscript);
      return var1 != null ? var1 : false;
   }

   public static boolean isUnderline(AttributeSet var0) {
      Boolean var1 = (Boolean)var0.getAttribute(Underline);
      return var1 != null ? var1 : false;
   }

   public static void setAlignment(MutableAttributeSet var0, int var1) {
      var0.addAttribute(Alignment, new Integer(var1));
   }

   public static void setBackground(MutableAttributeSet var0, Color var1) {
      var0.addAttribute(Background, var1);
   }

   public static void setBidiLevel(MutableAttributeSet var0, int var1) {
      var0.addAttribute(BidiLevel, new Integer(var1));
   }

   public static void setBold(MutableAttributeSet var0, boolean var1) {
      var0.addAttribute(Bold, new Boolean(var1));
   }

   public static void setComponent(MutableAttributeSet var0, Component var1) {
      var0.addAttribute("$ename", "component");
      var0.addAttribute(ComponentAttribute, var1);
   }

   public static void setFirstLineIndent(MutableAttributeSet var0, float var1) {
      var0.addAttribute(FirstLineIndent, new Float(var1));
   }

   public static void setFontFamily(MutableAttributeSet var0, String var1) {
      var0.addAttribute(FontFamily, var1);
   }

   public static void setFontSize(MutableAttributeSet var0, int var1) {
      var0.addAttribute(FontSize, new Integer(var1));
   }

   public static void setForeground(MutableAttributeSet var0, Color var1) {
      var0.addAttribute(Foreground, var1);
   }

   public static void setIcon(MutableAttributeSet var0, Icon var1) {
      var0.addAttribute("$ename", "icon");
      var0.addAttribute(IconAttribute, var1);
   }

   public static void setItalic(MutableAttributeSet var0, boolean var1) {
      var0.addAttribute(Italic, new Boolean(var1));
   }

   public static void setLeftIndent(MutableAttributeSet var0, float var1) {
      var0.addAttribute(LeftIndent, new Float(var1));
   }

   public static void setLineSpacing(MutableAttributeSet var0, float var1) {
      var0.addAttribute(LineSpacing, new Float(var1));
   }

   public static void setRightIndent(MutableAttributeSet var0, float var1) {
      var0.addAttribute(RightIndent, new Float(var1));
   }

   public static void setSpaceAbove(MutableAttributeSet var0, float var1) {
      var0.addAttribute(SpaceAbove, new Float(var1));
   }

   public static void setSpaceBelow(MutableAttributeSet var0, float var1) {
      var0.addAttribute(SpaceBelow, new Float(var1));
   }

   public static void setStrikeThrough(MutableAttributeSet var0, boolean var1) {
      var0.addAttribute(StrikeThrough, new Boolean(var1));
   }

   public static void setSubscript(MutableAttributeSet var0, boolean var1) {
      var0.addAttribute(Subscript, new Boolean(var1));
   }

   public static void setSuperscript(MutableAttributeSet var0, boolean var1) {
      var0.addAttribute(Superscript, new Boolean(var1));
   }

   public static void setTabSet(MutableAttributeSet var0, TabSet var1) {
      var0.addAttribute(TabSet, var1);
   }

   public static void setUnderline(MutableAttributeSet var0, boolean var1) {
      var0.addAttribute(Underline, new Boolean(var1));
   }

   public String toString() {
      return this.representation;
   }
}
