package javax.swing.text.html;

import java.awt.Point;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionListener;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.EventObject;
import javax.swing.JEditorPane;
import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkEvent.EventType;
import javax.swing.text.AttributeSet;
import javax.swing.text.DefaultStyledDocument;
import javax.swing.text.Document;
import javax.swing.text.Element;
import javax.swing.text.JTextComponent;
import javax.swing.text.html.HTML.Attribute;
import javax.swing.text.html.HTML.Tag;

class HTMLEditorKit$TemporaryHandler implements MouseMotionListener {
   private Element curElem = null;
   private String href = null;

   void fireEvents(JEditorPane var1, HTMLDocument var2, String var3) {
      if (this.href != null) {
         URL var4;
         try {
            var4 = new URL(var2.getBase(), this.href);
         } catch (MalformedURLException var7) {
            var4 = null;
         }

         HyperlinkEvent var5 = new HyperlinkEvent(var1, EventType.EXITED, var4, this.href);
         var1.fireHyperlinkUpdate(var5);
      }

      if (var3 != null) {
         URL var8;
         try {
            var8 = new URL(var2.getBase(), var3);
         } catch (MalformedURLException var6) {
            var8 = null;
         }

         HyperlinkEvent var9 = new HyperlinkEvent(var1, EventType.ENTERED, var8, var3);
         var1.fireHyperlinkUpdate(var9);
      }

   }

   public void mouseDragged(MouseEvent var1) {
   }

   public void mouseMoved(MouseEvent var1) {
      JEditorPane var2 = (JEditorPane)((EventObject)var1).getSource();
      if (!((JTextComponent)var2).isEditable()) {
         Point var3 = new Point(var1.getX(), var1.getY());
         int var4 = ((JTextComponent)var2).viewToModel(var3);
         if (var4 >= 0) {
            Document var5 = ((JTextComponent)var2).getDocument();
            if (var5 instanceof HTMLDocument) {
               HTMLDocument var6 = (HTMLDocument)var5;
               Element var7 = ((DefaultStyledDocument)var6).getCharacterElement(var4);
               if (this.curElem != var7) {
                  this.curElem = var7;
                  AttributeSet var8 = var7.getAttributes();
                  AttributeSet var9 = (AttributeSet)var8.getAttribute(Tag.A);
                  String var10 = var9 != null ? (String)var9.getAttribute(Attribute.HREF) : null;
                  if (var10 != this.href) {
                     this.fireEvents(var2, var6, var10);
                     this.href = var10;
                  }
               }
            }
         }
      }

   }
}
