package javax.swing.text.html;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLEncoder;
import javax.swing.JComponent;
import javax.swing.JEditorPane;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.text.AttributeSet;
import javax.swing.text.ComponentView;
import javax.swing.text.Element;
import javax.swing.text.View;
import javax.swing.text.html.HTML.Attribute;

class IsindexView extends ComponentView implements ActionListener {
   public static final String DEFAULT_PROMPT = "This is a searchable index.  Enter search keywords:";
   JTextField textField;

   public IsindexView(Element var1) {
      super(var1);
   }

   public void actionPerformed(ActionEvent var1) {
      String var2 = this.textField.getText();
      if (var2 != null) {
         var2 = URLEncoder.encode(var2);
      }

      AttributeSet var3 = ((View)this).getElement().getAttributes();
      HTMLDocument var4 = (HTMLDocument)((View)this).getElement().getDocument();
      String var5 = (String)var3.getAttribute(Attribute.ACTION);
      if (var5 == null) {
         var5 = var4.getBase().toString();
      }

      try {
         URL var6 = new URL(var5 + "?" + var2);
         JEditorPane var7 = (JEditorPane)((View)this).getContainer();
         var7.setPage(var6);
      } catch (MalformedURLException var8) {
      } catch (IOException var9) {
      }

   }

   public Component createComponent() {
      AttributeSet var1 = ((View)this).getElement().getAttributes();
      JPanel var2 = new JPanel(new BorderLayout());
      ((JComponent)var2).setBackground((Color)null);
      String var3 = (String)var1.getAttribute(Attribute.PROMPT);
      if (var3 == null) {
         var3 = "This is a searchable index.  Enter search keywords:";
      }

      JLabel var4 = new JLabel(var3);
      this.textField = new JTextField();
      this.textField.addActionListener(this);
      ((Container)var2).add(var4, "West");
      ((Container)var2).add(this.textField, "Center");
      ((JComponent)var2).setAlignmentY(1.0F);
      ((JComponent)var2).setOpaque(false);
      return var2;
   }
}
