package javax.swing.text.html;

import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Rectangle;
import java.awt.Toolkit;
import javax.swing.text.Document;
import javax.swing.text.Element;
import javax.swing.text.StyleConstants;
import javax.swing.text.StyledDocument;
import javax.swing.text.View;

class LineView extends ParagraphView {
   int tabBase;

   public LineView(Element var1) {
      super(var1);
   }

   public float getAlignment(int var1) {
      return var1 == 0 ? 0.0F : super.getAlignment(var1);
   }

   protected int getCharactersPerTab() {
      return 8;
   }

   public float getMinimumSpan(int var1) {
      return ((ParagraphView)this).getPreferredSpan(var1);
   }

   protected float getPreTab(float var1, int var2) {
      Document var3 = ((View)this).getDocument();
      View var4 = ((javax.swing.text.ParagraphView)this).getViewAtPosition(var2, (Rectangle)null);
      if (var3 instanceof StyledDocument && var4 != null) {
         Font var5 = ((StyledDocument)var3).getFont(var4.getAttributes());
         FontMetrics var6 = Toolkit.getDefaultToolkit().getFontMetrics(var5);
         int var7 = this.getCharactersPerTab() * var6.charWidth('W');
         int var8 = (int)((javax.swing.text.ParagraphView)this).getTabBase();
         return (float)((((int)var1 - var8) / var7 + 1) * var7 + var8);
      } else {
         return 10.0F + var1;
      }
   }

   public int getResizeWeight(int var1) {
      switch (var1) {
         case 0:
            return 1;
         case 1:
            return 0;
         default:
            throw new IllegalArgumentException("Invalid axis: " + var1);
      }
   }

   public boolean isVisible() {
      return true;
   }

   protected void layout(int var1, int var2) {
      super.layout(2147483646, var2);
   }

   public float nextTabStop(float var1, int var2) {
      return ((javax.swing.text.ParagraphView)this).getTabSet() == null && StyleConstants.getAlignment(((ParagraphView)this).getAttributes()) == 0 ? this.getPreTab(var1, var2) : super.nextTabStop(var1, var2);
   }
}
