package javax.swing.text.html;

import java.util.Enumeration;
import javax.swing.text.AttributeSet;
import javax.swing.text.SimpleAttributeSet;

class StyleSheet$MuxingAttributeSet implements AttributeSet {
   AttributeSet[] attrs;

   StyleSheet$MuxingAttributeSet() {
   }

   StyleSheet$MuxingAttributeSet(AttributeSet[] var1) {
      this.attrs = var1;
   }

   public boolean containsAttribute(Object var1, Object var2) {
      return var2.equals(this.getAttribute(var1));
   }

   public boolean containsAttributes(AttributeSet var1) {
      boolean var2 = true;

      Object var4;
      for(Enumeration var3 = var1.getAttributeNames(); var2 && var3.hasMoreElements(); var2 = var1.getAttribute(var4).equals(this.getAttribute(var4))) {
         var4 = var3.nextElement();
      }

      return var2;
   }

   public AttributeSet copyAttributes() {
      AttributeSet[] var1 = this.getAttributes();
      SimpleAttributeSet var2 = new SimpleAttributeSet();
      boolean var3 = false;

      for(int var4 = var1.length - 1; var4 >= 0; --var4) {
         var2.addAttributes(var1[var4]);
      }

      return var2;
   }

   public Object getAttribute(Object var1) {
      AttributeSet[] var2 = this.getAttributes();
      int var3 = var2.length;

      for(int var4 = 0; var4 < var3; ++var4) {
         Object var5 = var2[var4].getAttribute(var1);
         if (var5 != null) {
            return var5;
         }
      }

      return null;
   }

   public int getAttributeCount() {
      AttributeSet[] var1 = this.getAttributes();
      int var2 = 0;

      for(int var3 = 0; var3 < var1.length; ++var3) {
         var2 += var1[var3].getAttributeCount();
      }

      return var2;
   }

   public Enumeration getAttributeNames() {
      return new StyleSheet.MuxingAttributeSet.MuxingAttributeNameEnumeration(this);
   }

   protected synchronized AttributeSet[] getAttributes() {
      return this.attrs;
   }

   public AttributeSet getResolveParent() {
      return null;
   }

   protected synchronized void insertAttributeSetAt(AttributeSet var1, int var2) {
      int var3 = this.attrs.length;
      AttributeSet[] var4 = new AttributeSet[var3 + 1];
      if (var2 < var3) {
         if (var2 > 0) {
            System.arraycopy(this.attrs, 0, var4, 0, var2);
            System.arraycopy(this.attrs, var2, var4, var2 + 1, var3 - var2);
         } else {
            System.arraycopy(this.attrs, 0, var4, 1, var3);
         }
      } else {
         System.arraycopy(this.attrs, 0, var4, 0, var3);
      }

      var4[var2] = var1;
      this.attrs = var4;
   }

   public boolean isDefined(Object var1) {
      AttributeSet[] var2 = this.getAttributes();

      for(int var3 = 0; var3 < var2.length; ++var3) {
         if (var2[var3].isDefined(var1)) {
            return true;
         }
      }

      return false;
   }

   public boolean isEqual(AttributeSet var1) {
      return this.getAttributeCount() == var1.getAttributeCount() && this.containsAttributes(var1);
   }

   protected synchronized void removeAttributeSetAt(int var1) {
      int var2 = this.attrs.length;
      AttributeSet[] var3 = new AttributeSet[var2 - 1];
      if (var2 > 0) {
         if (var1 == 0) {
            System.arraycopy(this.attrs, 1, var3, 0, var2 - 1);
         } else if (var1 < var2 - 1) {
            System.arraycopy(this.attrs, 0, var3, 0, var1);
            System.arraycopy(this.attrs, var1 + 1, var3, var1, var2 - var1 - 1);
         } else {
            System.arraycopy(this.attrs, 0, var3, 0, var2 - 1);
         }
      }

      this.attrs = var3;
   }

   protected synchronized void setAttributes(AttributeSet[] var1) {
      this.attrs = var1;
   }
}
