package javax.swing.text.rtf;

import java.io.IOException;
import javax.swing.text.MutableAttributeSet;

class RTFAttributes$BooleanAttribute extends RTFAttributes.GenericAttribute implements RTFAttribute {
   boolean rtfDefault;
   boolean swingDefault;
   protected static final Boolean True = new Boolean(true);
   protected static final Boolean False = new Boolean(false);

   public RTFAttributes$BooleanAttribute(int var1, Object var2, String var3) {
      super(var1, var2, var3);
      this.swingDefault = false;
      this.rtfDefault = false;
   }

   public RTFAttributes$BooleanAttribute(int var1, Object var2, String var3, boolean var4, boolean var5) {
      super(var1, var2, var3);
      this.swingDefault = var4;
      this.rtfDefault = var5;
   }

   public boolean set(MutableAttributeSet var1) {
      var1.addAttribute(super.swingName, True);
      return true;
   }

   public boolean set(MutableAttributeSet var1, int var2) {
      Boolean var3 = var2 != 0 ? True : False;
      var1.addAttribute(super.swingName, var3);
      return true;
   }

   public boolean setDefault(MutableAttributeSet var1) {
      if (this.swingDefault != this.rtfDefault || var1.getAttribute(super.swingName) != null) {
         var1.addAttribute(super.swingName, new Boolean(this.rtfDefault));
      }

      return true;
   }

   public boolean writeValue(Object var1, RTFGenerator var2, boolean var3) throws IOException {
      Boolean var4;
      if (var1 == null) {
         var4 = new Boolean(this.swingDefault);
      } else {
         var4 = (Boolean)var1;
      }

      if (var3 || var4 != this.rtfDefault) {
         if (var4) {
            var2.writeControlWord(super.rtfName);
         } else {
            var2.writeControlWord(super.rtfName, 0);
         }
      }

      return true;
   }
}
