package javax.swing.text.rtf;

import java.io.IOException;
import javax.swing.text.MutableAttributeSet;

class RTFAttributes$NumericAttribute extends RTFAttributes.GenericAttribute implements RTFAttribute {
   int rtfDefault;
   Number swingDefault;
   float scale;

   protected RTFAttributes$NumericAttribute(int var1, Object var2, String var3) {
      super(var1, var2, var3);
      this.rtfDefault = 0;
      this.swingDefault = null;
      this.scale = 1.0F;
   }

   public RTFAttributes$NumericAttribute(int var1, Object var2, String var3, int var4, int var5) {
      this(var1, var2, var3, new Integer(var4), var5, 1.0F);
   }

   public RTFAttributes$NumericAttribute(int var1, Object var2, String var3, Number var4, int var5, float var6) {
      super(var1, var2, var3);
      this.swingDefault = var4;
      this.rtfDefault = var5;
      this.scale = var6;
   }

   public static RTFAttributes$NumericAttribute NewTwips(int var0, Object var1, String var2, float var3, int var4) {
      return new RTFAttributes$NumericAttribute(var0, var1, var2, new Float(var3), var4, 20.0F);
   }

   public static RTFAttributes$NumericAttribute NewTwips(int var0, Object var1, String var2, int var3) {
      return new RTFAttributes$NumericAttribute(var0, var1, var2, (Number)null, var3, 20.0F);
   }

   public boolean set(MutableAttributeSet var1) {
      return false;
   }

   public boolean set(MutableAttributeSet var1, int var2) {
      Object var3;
      if (this.scale == 1.0F) {
         var3 = new Integer(var2);
      } else {
         var3 = new Float((float)var2 / this.scale);
      }

      var1.addAttribute(super.swingName, var3);
      return true;
   }

   public boolean setDefault(MutableAttributeSet var1) {
      Number var2 = (Number)var1.getAttribute(super.swingName);
      if (var2 == null) {
         var2 = this.swingDefault;
      }

      if (var2 == null || (this.scale != 1.0F || var2.intValue() != this.rtfDefault) && Math.round(var2.floatValue() * this.scale) != this.rtfDefault) {
         this.set(var1, this.rtfDefault);
         return true;
      } else {
         return true;
      }
   }

   public boolean writeValue(Object var1, RTFGenerator var2, boolean var3) throws IOException {
      Number var4 = (Number)var1;
      if (var4 == null) {
         var4 = this.swingDefault;
      }

      if (var4 == null) {
         return true;
      } else {
         int var5 = Math.round(var4.floatValue() * this.scale);
         if (var3 || var5 != this.rtfDefault) {
            var2.writeControlWord(super.rtfName, var5);
         }

         return true;
      }
   }
}
