package javax.swing.text;

import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Rectangle;
import java.awt.Shape;
import javax.swing.SwingUtilities;
import javax.swing.text.Position.Bias;

public class ComponentView extends View {
   private Component createdC;
   // $FF: renamed from: c java.awt.Component
   private Component field_0;

   public ComponentView(Element var1) {
      super(var1);
   }

   // $FF: synthetic method
   static Component access$0(ComponentView var0) {
      return var0.field_0;
   }

   protected Component createComponent() {
      AttributeSet var1 = ((View)this).getElement().getAttributes();
      Component var2 = StyleConstants.getComponent(var1);
      return var2;
   }

   public float getAlignment(int var1) {
      if (this.field_0 != null) {
         switch (var1) {
            case 0:
               return this.field_0.getAlignmentX();
            case 1:
               return this.field_0.getAlignmentY();
         }
      }

      return super.getAlignment(var1);
   }

   public final Component getComponent() {
      return this.createdC;
   }

   public float getMaximumSpan(int var1) {
      if (this.field_0 != null) {
         Dimension var2 = this.field_0.getMaximumSize();
         switch (var1) {
            case 0:
               return (float)var2.width;
            case 1:
               return (float)var2.height;
            default:
               throw new IllegalArgumentException("Invalid axis: " + var1);
         }
      } else {
         return 0.0F;
      }
   }

   public float getMinimumSpan(int var1) {
      if (this.field_0 != null) {
         Dimension var2 = this.field_0.getMinimumSize();
         switch (var1) {
            case 0:
               return (float)var2.width;
            case 1:
               return (float)var2.height;
            default:
               throw new IllegalArgumentException("Invalid axis: " + var1);
         }
      } else {
         return 0.0F;
      }
   }

   public float getPreferredSpan(int var1) {
      if (this.field_0 != null) {
         Dimension var2 = this.field_0.getPreferredSize();
         switch (var1) {
            case 0:
               return (float)var2.width;
            case 1:
               return (float)var2.height;
            default:
               throw new IllegalArgumentException("Invalid axis: " + var1);
         }
      } else {
         return 0.0F;
      }
   }

   public Shape modelToView(int var1, Shape var2, Position.Bias var3) throws BadLocationException {
      int var4 = ((View)this).getStartOffset();
      int var5 = ((View)this).getEndOffset();
      if (var1 >= var4 && var1 <= var5) {
         Rectangle var6 = var2.getBounds();
         if (var1 == var5) {
            var6.x += var6.width;
         }

         var6.width = 0;
         return var6;
      } else {
         throw new BadLocationException(var1 + " not in range " + var4 + "," + var5, var1);
      }
   }

   public void paint(Graphics var1, Shape var2) {
      if (this.field_0 != null) {
         this.field_0.setBounds(var2.getBounds());
         if (!this.field_0.isVisible()) {
            this.field_0.setVisible(true);
         }
      }

   }

   void setComponentParent() {
      View var1 = ((View)this).getParent();
      if (var1 == null) {
         if (this.field_0 != null) {
            Container var2 = this.field_0.getParent();
            if (var2 != null) {
               var2.remove(this.field_0);
            }
         }
      } else {
         if (this.field_0 == null) {
            Component var3 = this.createComponent();
            if (var3 != null) {
               this.createdC = var3;
               this.field_0 = new Invalidator(this, var3);
               this.field_0.setVisible(false);
            }
         }

         if (this.field_0 != null && this.field_0.getParent() == null) {
            Container var4 = ((View)this).getContainer();
            var4.add(this.field_0);
         }
      }

   }

   public void setParent(View var1) {
      super.setParent(var1);
      if (SwingUtilities.isEventDispatchThread()) {
         this.setComponentParent();
      } else {
         1 var2 = new 1(this);
         SwingUtilities.invokeLater(var2);
      }

   }

   public void setSize(float var1, float var2) {
      if (this.field_0 != null) {
         if (SwingUtilities.isEventDispatchThread()) {
            this.field_0.setSize((int)var1, (int)var2);
         } else {
            SafeResizer var3 = new SafeResizer(this, (int)var1, (int)var2);
            SwingUtilities.invokeLater(var3);
         }
      }

   }

   public int viewToModel(float var1, float var2, Shape var3, Position.Bias[] var4) {
      Rectangle var5 = (Rectangle)var3;
      if (var1 < (float)(var5.x + var5.width / 2)) {
         var4[0] = Bias.Forward;
         return ((View)this).getStartOffset();
      } else {
         var4[0] = Bias.Backward;
         return ((View)this).getEndOffset();
      }
   }
}
