package javax.swing.text.html;

import java.util.Enumeration;
import java.util.Vector;
import javax.swing.text.AttributeSet;
import javax.swing.text.Document;
import javax.swing.text.Element;
import javax.swing.text.Style;
import javax.swing.text.StyleConstants;
import javax.swing.text.View;
import javax.swing.text.html.HTML.Attribute;
import javax.swing.text.html.HTML.Tag;
import javax.swing.text.html.StyleSheet.SearchBuffer;

class StyleSheet$ViewAttributeSet extends StyleSheet.MuxingAttributeSet {
   // $FF: synthetic field
   private final StyleSheet this$0;
   View host;

   StyleSheet$ViewAttributeSet(StyleSheet var1, View var2) {
      this.this$0 = var1;
      this.host = var2;
      Document var3 = var2.getDocument();
      StyleSheet.SearchBuffer var4 = SearchBuffer.obtainSearchBuffer();
      Vector var5 = var4.getVector();

      try {
         if (var3 instanceof HTMLDocument) {
            StyleSheet var8 = var1;
            Element var9 = var2.getElement();
            AttributeSet var10 = var9.getAttributes();
            AttributeSet var11 = var1.translateHTMLToCSS(var10);
            if (var11.getAttributeCount() != 0) {
               var5.addElement(var11);
            }

            if (!var9.isLeaf()) {
               HTML.Tag var18 = (HTML.Tag)var10.getAttribute(StyleConstants.NameAttribute);
               if (var18 == Tag.IMPLIED) {
                  var18 = Tag.P;
               }

               Style var19 = var1.getRule(var18, var9);
               if (var19 != null) {
                  var5.addElement(var19);
               }
            } else {
               Enumeration var12 = var10.getAttributeNames();

               while(var12.hasMoreElements()) {
                  Object var13 = var12.nextElement();
                  if (var13 instanceof HTML.Tag) {
                     if ((HTML.Tag)var13 == Tag.A) {
                        Object var14 = var10.getAttribute((HTML.Tag)var13);
                        if (var14 != null && var14 instanceof AttributeSet) {
                           AttributeSet var15 = (AttributeSet)var14;
                           if (var15.getAttribute(Attribute.HREF) == null) {
                              continue;
                           }
                        }
                     }

                     Style var20 = var8.getRule((HTML.Tag)var13, var9);
                     if (var20 != null) {
                        var5.addElement(var20);
                     }
                  }
               }
            }
         }

         super.attrs = new AttributeSet[var5.size()];
         var5.copyInto(super.attrs);
      } finally {
         SearchBuffer.releaseSearchBuffer(var4);
      }

   }

   Object doGetAttribute(Object var1) {
      Object var2 = super.getAttribute(var1);
      if (var2 != null) {
         return var2;
      } else {
         if (var1 instanceof CSS.Attribute) {
            CSS.Attribute var3 = (CSS.Attribute)var1;
            if (var3.isInherited()) {
               AttributeSet var4 = this.getResolveParent();
               if (var4 != null) {
                  return var4.getAttribute(var1);
               }
            }
         }

         return null;
      }
   }

   public Object getAttribute(Object var1) {
      if (var1 instanceof StyleConstants) {
         CSS.Attribute var2 = StyleSheet.access$0(this.this$0).styleConstantsKeyToCSSKey((StyleConstants)var1);
         if (var2 != null) {
            Object var3 = this.doGetAttribute(var2);
            if (var3 instanceof CSS.CssValue) {
               return ((CSS.CssValue)var3).toStyleConstants((StyleConstants)var1);
            }
         }
      }

      return this.doGetAttribute(var1);
   }

   public AttributeSet getResolveParent() {
      if (this.host == null) {
         return null;
      } else {
         View var1 = this.host.getParent();
         return var1 != null ? var1.getAttributes() : null;
      }
   }

   public boolean isDefined(Object var1) {
      if (var1 instanceof StyleConstants) {
         CSS.Attribute var2 = StyleSheet.access$0(this.this$0).styleConstantsKeyToCSSKey((StyleConstants)var1);
         if (var2 != null) {
            var1 = var2;
         }
      }

      return super.isDefined(var1);
   }
}
