package javax.swing.text.rtf;

import javax.swing.text.AttributeSet;
import javax.swing.text.MutableAttributeSet;

abstract class RTFReader$TextHandlingDestination extends RTFReader.AttributeTrackingDestination implements RTFReader.Destination {
   // $FF: synthetic field
   private final RTFReader this$0;
   boolean inParagraph;

   public RTFReader$TextHandlingDestination(RTFReader var1) {
      super(var1);
      this.this$0 = var1;
      this.inParagraph = false;
   }

   protected void beginParagraph() {
      this.inParagraph = true;
   }

   public void close() {
      if (this.inParagraph) {
         this.endParagraph();
      }

      super.close();
   }

   abstract void deliverText(String var1, AttributeSet var2);

   protected void endParagraph() {
      MutableAttributeSet var1 = ((RTFReader.AttributeTrackingDestination)this).currentParagraphAttributes();
      MutableAttributeSet var2 = ((RTFReader.AttributeTrackingDestination)this).currentTextAttributes();
      this.finishParagraph(var1, var2);
      this.inParagraph = false;
   }

   abstract void endSection();

   abstract void finishParagraph(AttributeSet var1, AttributeSet var2);

   public boolean handleKeyword(String var1) {
      if (var1.equals("\r") || var1.equals("\n")) {
         var1 = "par";
      }

      if (var1.equals("par")) {
         this.endParagraph();
         return true;
      } else if (var1.equals("sect")) {
         this.endSection();
         return true;
      } else {
         return super.handleKeyword(var1);
      }
   }

   public void handleText(String var1) {
      if (!this.inParagraph) {
         this.beginParagraph();
      }

      this.deliverText(var1, ((RTFReader.AttributeTrackingDestination)this).currentTextAttributes());
   }
}
